# User API

## asdf Package

asdf: Python library for reading and writing Advanced Scientific Data Format (ASDF) files

### Functions

`open`(fd[, uri, mode, validate_checksums, ...]) | Open an existing ASDF file.
`info`(node_or_path[, max_rows, max_cols, ...]) | Print a rendering of an ASDF tree or sub-tree to stdout.
`get_config`() | Get the current config, which may have been altered by one or more surrounding calls to `asdf.config_context`.
`config_context`() | Context manager that temporarily overrides asdf configuration.

### Classes

`AsdfFile`([tree, uri, extensions, version, ...]) | The main class that represents an ASDF file object.
`CustomType`() | Base class for all user-defined types.
`Stream`(shape, dtype[, strides]) | Used to put a streamed array into the tree.
`IntegerType`(value[, storage_type]) | Enables the storage of arbitrarily large integer values
`ExternalArrayReference`(fileuri, target, ...) | Store a reference to an array in an external File.

### Variables

`__version__` | str(object='') -> str str(bytes_or_buffer[, encoding[, errors]]) -> str

### Class Inheritance Diagram

## asdf.search Module

Utilities for searching ASDF trees.

### Classes

`AsdfSearchResult`(identifiers, node[, ...]) | Result of a call to AsdfFile.search.

### Class Inheritance Diagram

## asdf.config Module

Methods for getting and setting asdf global configuration options.

### Functions

`get_config`() | Get the current config, which may have been altered by one or more surrounding calls to `asdf.config_context`.
`config_context`() | Context manager that temporarily overrides asdf configuration.

### Classes

`AsdfConfig`() | Container for ASDF configuration options.

### Class Inheritance Diagram